﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Lista_kaczek
{

    class Bird {
        public string Name { get; set; }
        public void Fly()
        {
            Console.WriteLine("Frr..., frr...");
        }
        public override string ToString()
        {
            return "Ptak " + Name;
        }
    }

    class Penguin : Bird { 
        public void Fly() {
            Console.WriteLine("Pingwiny nie latają!");
        }
        public override string ToString() {
            return "Pingwin " + base.Name;
        }    
    }


    class Program
    {
        static void Main(string[] args)
        {
            List<Duck> ducks = new List<Duck>() {
                new Duck() { Kind = KindOfDuck.Mallard, Size = 17 },
                new Duck() { Kind = KindOfDuck.Muscovy, Size = 18 },
                new Duck() { Kind = KindOfDuck.Decoy, Size = 14 },
                new Duck() { Kind = KindOfDuck.Muscovy, Size = 11 },
                new Duck() { Kind = KindOfDuck.Mallard, Size = 14 },
                new Duck() { Kind = KindOfDuck.Decoy, Size = 13 },
            };


            ducks.Sort();


            DuckComparerBySize sizeComparer = new DuckComparerBySize();
            ducks.Sort(sizeComparer);
            PrintDucks(ducks);

            DuckComparerByKind kindComparer = new DuckComparerByKind();
            ducks.Sort(kindComparer);
            PrintDucks(ducks);

            DuckComparer comparer = new DuckComparer();

            comparer.SortBy = SortCriteria.KindThenSize;
            ducks.Sort(comparer);
            PrintDucks(ducks);

            comparer.SortBy = SortCriteria.SizeThenKind;
            ducks.Sort(comparer);
            PrintDucks(ducks);
 
            // Dzięki temu wywołaniu wyniki nie znikną od razu po wyświetleniu listy kaczek
            Console.ReadKey();

        }

        public static void PrintDucks(List<Duck> ducks)
        {
            foreach (Duck duck in ducks)
            {
                Console.WriteLine(duck);
            }
            Console.WriteLine("Koniec listy kaczek!");
        }
    }
}