﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LINQ_jest_wszechstronny
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Modyfikacja każdego elementu zwróconego przez zapytanie\n");

            string[] sandwiches = { "szynka i ser", "salami z majonezem",
                                    "indyk i ser szwajcarski", "kotlet z kurczaka" }; 
            var sandwichesOnRye =
                from sandwich in sandwiches
                select sandwich + " na chlebie zbożowym";

            foreach (var sandwich in sandwichesOnRye)
                Console.WriteLine(sandwich);


            Console.WriteLine("\nPerform calculations on collectons\n");

            Random random = new Random();
            List<int> listOfNumbers = new List<int>();
            int length = random.Next(50, 150);
            for (int i = 0; i < length; i++)
                listOfNumbers.Add(random.Next(100));

            Console.WriteLine("Na liście znajduje się {0} liczb",
                                  listOfNumbers.Count());
            Console.WriteLine("Najmniejsza z nich to {0}",
                                  listOfNumbers.Min());
            Console.WriteLine("Największa z nich to {0}",
                                  listOfNumbers.Max());
            Console.WriteLine("Suma wynosi {0}",
                                  listOfNumbers.Sum());
            Console.WriteLine("Średnia wynosi {0:F2}",
                                  listOfNumbers.Average());


            Console.WriteLine("\nZapis całych lub fragmentu wyników w nowej kolekcji\n");

            var under50sorted =
              from number in listOfNumbers
              where number < 50
              orderby number descending
              select number;

            List<int> newList = under50sorted.ToList();

            var firstFive = under50sorted.Take(6);

            List<int> shortList = firstFive.ToList();
            foreach (int n in shortList)
                Console.WriteLine(n);

            Console.ReadKey();
        }
    }
}